"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// builtin
const fs_1 = require("fs");
const process_1 = require("process");
const nodeVersion = String(process_1.versions.node || '0');
// external
const fs_accessible_1 = __importStar(require("@bevry/fs-accessible"));
const errlop_1 = __importDefault(require("errlop"));
/** Remove a file. */
async function unlink(path) {
    if (Array.isArray(path)) {
        return Promise.all(path.map((i) => unlink(i))).then(() => { });
    }
    // check exists
    try {
        await (0, fs_accessible_1.default)(path);
    }
    catch (err) {
        // if it doesn't exist, then we don't care
        return;
    }
    // check writable
    try {
        await (0, fs_accessible_1.default)(path, fs_accessible_1.W_OK);
    }
    catch (err) {
        if (err.code === 'ENOENT') {
            // if it doesn't exist, then we don't care (this may not seem necessary due to the earlier accessible check, however it is necessary, testen would fail on @bevry/json otherwise)
            return;
        }
        throw new errlop_1.default(`unable to remove the non-writable file: ${path}`, err);
    }
    // remove the file
    return new Promise(function (resolve, reject) {
        (0, fs_1.unlink)(path, function (err) {
            if (err) {
                return reject(new errlop_1.default(`failed to remove the accessible and writable file: ${path}`, err));
            }
            return resolve();
        });
    });
}
exports.default = unlink;
